<template>
  <div>
    <div class="row">
      <div class="col-md-12 columns no-gutters">
          <h3>{{ $t('simualteur.meslistes') }} <b-button style="margin-left: 0.5rem" id="popup-leslistes" class="btn btn-popup">?</b-button> </h3>
          <b-popover ref="popover" target="popup-leslistes" triggers="focus">
              Ajoutez jusqu'à dix listes que vous pourrez renommer par la suite.<br/>
          </b-popover>

          <div class="input-group input-group-rounded-double col-md-12">
            <input
                v-model="nom"
                class="input-group-field pl-5"
                float-label="Nom de la liste"
                numeric-keyboard-toggle
                placeholder="Nom de la liste"
                type="text"
                value=""
            />
            <div class="input-group-button">
              <button @click="addLine" icon="playlist-plus"  class="button secondary ajouter" round>{{ $t('simualteur.ajouterliste') }}</button>
            </div>
          </div>

      </div>

  </div>

  <section class="grid-container listes-villes">
      <hr />

      <MessageBox type="simulateur" icon='images/warning.png' v-if="tour == 1 && pourcentageRestantCondition != 0" :message="'Lors du second tour 100% des suffrages doivent être attribués.<br/>Reste à attribuer : '+Math.abs(pourcentageRestantCondition)+'%'" />

      <div class="row" v-if="lines.length > 0">
          <div class="col-md-8">
              <span v-if="tour == 0">Reste à attribuer : {{ pourcentageRestantCondition }}%</span>
          </div>
          <div class="col-md-4">
              ( Estimez en pourcentage )
          </div>
      </div>
      <div class="row mt-3 mb-3 item-ville" v-for="(line, index) in lines" v-bind:key="index">
          <div class="col-sm-6 col-md-8 liste-title">
              <div class="circle">
                  <span>{{ index + 1 }}.</span>
              </div>
              <div class="title" contenteditable="true" @blur="nameUpdate(line, index, $event)" v-text="line.nom"></div>

          </div>
          <div class="col-sm-6 col-md-4">
              <div class="row">
                  <div class="input-group input-group-rounded col-9 col-md-9">
                      <div class="input-pourcentage">
                          <input
                            class="input-group-field"
                            v-model="line.pourcentage"
                            float-label="Nom de la liste"
                            numeric-keyboard-toggle
                            placeholder="%"
                            type="number"
                            value=""
                            min="0"
                            max="100"
                            v-on:click="handleUpdate(line, index, $event)"
                            v-on:keyup="handleUpdate(line, index, $event)"
                            v-on:paste="handleUpdate(line, index, $event)"
                          />
                      </div>
                    </div>
                    <div class="col-3 col-md-2">
                      <button @click="ModalRemoveLine(index)" class="button-delete" icon="delete" round>X</button>
                    </div>
                </div>
          </div>
      </div>
  </section>

   <!-- The modal -->
   <b-modal ref="my-modal" hide-footer>
      <div class="d-block text-center">
        <h3>Êtes-vous sûr de vouloir supprimer cette liste ?</h3>
      </div>
      <b-button class="mt-3" variant="outline-generic" block @click="hideModal">Annuler</b-button>
      <b-button class="mt-2" variant="outline-danger" block @click="removeLine">Supprimer</b-button>
    </b-modal>

  </div>
</template>

<script>

import { villeGetters } from '@/store/ville.js';

import MessageBox from '@/components/simulateur/parts/MessageBox.vue'

export default {
  name: 'addFields',
  data () {
    return {
      lines: [],
      lineSelected: null,
      localStorage: [],
      blockRemoval: true,
      nom: null,
      vonce: true
    }
  },
  components: {
      MessageBox
  },
  computed: {
      ...villeGetters
  },
  watch: {
    lines () {
      this.blockRemoval = this.lines.length <= 1
    },
    tour: function() {
        this.loadLines();
    }
  },
  methods: {
    handleUpdate(entry, entryIndex, event) {
        this.calculPourcentageTotal(this.lines);
        var newValue = event.target.value;
        newValue = newValue.replace(',', '.');

        let data = this.localStorage;
        data[this.ville.Id_ville_insee][this.tour][entryIndex].pourcentage = newValue;

        localStorage.setItem('datas', JSON.stringify(data));
    },
    addLine () {
      // let checkEmptyLines = this.nom.filter(line => line.number === null)
      let nom = this.nom;
      if(this.lines.length >= 10) return false;
      if (this.nom === "" || this.nom === null){
          nom = 'liste '+(this.lines.length + 1);
      }

      this.nom = '';

      let val = this.lines.push({
          nom: nom,
          pourcentage: null
      });

      let data = this.localStorage;
      if(data.length == 0){
          data = {};
          data[this.ville.Id_ville_insee] = [];
      }
      else if(typeof data[this.ville.Id_ville_insee] == 'undefined'){
          data[this.ville.Id_ville_insee] = [];
      }

      data[this.ville.Id_ville_insee][this.tour] = this.lines;

      localStorage.setItem('datas', JSON.stringify(data));
      this.localStorage = data;

      return val;
    },
    ModalRemoveLine(lineId){
        this.lineSelected = lineId;
        this.$refs['my-modal'].show()
    },
    hideModal() {
        this.$refs['my-modal'].hide()
    },
    removeLine(){
      if(this.lineSelected != null){
          this.lines.splice(this.lineSelected, 1);

          let data = this.localStorage;

          data[this.ville.Id_ville_insee][this.tour] = this.lines;
          localStorage.setItem('datas', JSON.stringify(data));

          this.calculPourcentageTotal(this.lines);

          this.lineSelected = null;
      }

      this.hideModal();
    },
    loadLines() {
        if (localStorage.datas) {
            this.localStorage = JSON.parse(localStorage.datas);

            this.lines = [];
            if(this.localStorage[this.ville.Id_ville_insee] != undefined && this.localStorage[this.ville.Id_ville_insee][this.tour] != undefined){
                this.lines = this.localStorage[this.ville.Id_ville_insee][this.tour];
            }

            // this.addLine()
        }
    },
    nameUpdate(entry, entryIndex, event){
        var newValue = event.target.textContent;

        let regex = /(<([^>]+)>)/ig;
        newValue = newValue.replace(regex, "");
        newValue = newValue.trim();

        let data = this.localStorage;
        data[this.ville.Id_ville_insee][this.tour][entryIndex].nom = newValue;

        localStorage.setItem('datas', JSON.stringify(data));

        return true;

        // return true;
    }
  },

  props: [
      'calculPourcentageTotal',
      'pourcentageRestantCondition'
  ],
  //Au chargement
  mounted () {
      this.loadLines();
      this.calculPourcentageTotal(this.lines);
  }
}
</script>
